"use strict";
/**
 * 数据结构 - 栈的实现
 *
 * Referer: https://medium.com/@_jmoller/javascript-data-structures-stacks-and-queues-ea877d72a5f9
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Stack = void 0;
class Stack {
    constructor(capacity = Infinity) {
        this.capacity = capacity;
        this.storage = [];
        this.count = 0;
    }
    push(element) {
        if (this.count >= this.capacity) {
            throw new Error('Max capacity is already reached.');
        }
        this.count += 1;
        return this.storage.push(element);
    }
    pop() {
        if (this.count > 0) {
            this.count -= 1;
            return this.storage.pop();
        }
    }
    peek() {
        return this.storage[this.size() - 1];
    }
    size() {
        return this.count;
    }
}
exports.Stack = Stack;
//# sourceMappingURL=stack.js.map